﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinToolbars;

namespace Empty_Ribbon2
{
    public partial class Form1 : Form, IUIElementDrawFilter
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraToolbarsManager1.DrawFilter = this;
        }

        bool IUIElementDrawFilter.DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            var imageElement = drawParams.Element as ImageAndTextUIElementEx.ImageAndTextDependentImageUIElement;
            if (imageElement != null)
            {
                var toolElement = imageElement.GetAncestor(typeof(ButtonToolUIElement));
                if (toolElement != null)
                {
                    var tool = imageElement.GetContext(typeof(ToolBase), true) as ToolBase;
                    if (tool != null)
                    {
                        if (this.imageList1.Images.ContainsKey(tool.Key))
                        {
                            drawParams.DrawImage(this.imageList1.Images[tool.Key], imageElement.Rect, false, null);
                            return true;
                        }
                    }
                }
            }
            return false;
        }

        DrawPhase IUIElementDrawFilter.GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is ImageAndTextUIElementEx.ImageAndTextDependentImageUIElement)
                return DrawPhase.BeforeDrawImage;
            return DrawPhase.None;
        }

        private void ultraToolbarsManager1_ToolClick(object sender, ToolClickEventArgs e)
        {

        }
    }
}
